"use strict";

function _interopDefault(ex) {
  return ex && "object" == typeof ex && "default" in ex ? ex.default : ex;
}

Object.defineProperty(exports, "__esModule", {
  value: !0
});

var _extends = _interopDefault(require("@babel/runtime/helpers/extends")), _defineProperty = _interopDefault(require("@babel/runtime/helpers/defineProperty")), _objectWithoutProperties = _interopDefault(require("@babel/runtime/helpers/objectWithoutProperties")), core = require("@westpac/core"), PropTypes = _interopDefault(require("prop-types"));

function ownKeys(object, enumerableOnly) {
  var keys = Object.keys(object);
  if (Object.getOwnPropertySymbols) {
    var symbols = Object.getOwnPropertySymbols(object);
    enumerableOnly && (symbols = symbols.filter((function(sym) {
      return Object.getOwnPropertyDescriptor(object, sym).enumerable;
    }))), keys.push.apply(keys, symbols);
  }
  return keys;
}

function _objectSpread(target) {
  for (var i = 1; i < arguments.length; i++) {
    var source = null != arguments[i] ? arguments[i] : {};
    i % 2 ? ownKeys(Object(source), !0).forEach((function(key) {
      _defineProperty(target, key, source[key]);
    })) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach((function(key) {
      Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key));
    }));
  }
  return target;
}

var Label = function(_ref) {
  _ref.state;
  var rest = _objectWithoutProperties(_ref, [ "state" ]);
  return core.jsx("span", rest);
}, labelStyles = function(_, _ref2) {
  var look = _ref2.look, _useBrand = core.useBrand(), COLORS = _useBrand.COLORS, TYPE = _useBrand.TYPE, color = "#fff";
  return "faint" === look && (color = COLORS.muted), _objectSpread(_objectSpread(_objectSpread({
    display: "inline-block",
    appearance: "none",
    borderRadius: "0.125rem",
    fontSize: "0.75rem",
    lineHeight: "normal",
    padding: "0.0625rem 0.375rem",
    textAlign: "center",
    verticalAlign: "baseline",
    whiteSpace: "nowrap"
  }, {
    primary: {
      color: color,
      backgroundColor: COLORS[look],
      border: "1px solid ".concat(COLORS[look])
    },
    hero: {
      color: color,
      backgroundColor: COLORS[look],
      border: "1px solid ".concat(COLORS[look])
    },
    neutral: {
      color: color,
      backgroundColor: COLORS[look],
      border: "1px solid ".concat(COLORS[look])
    },
    faint: {
      color: color,
      backgroundColor: COLORS.light,
      border: "1px solid ".concat(COLORS.border)
    },
    success: {
      color: color,
      backgroundColor: COLORS[look],
      border: "1px solid ".concat(COLORS[look])
    },
    info: {
      color: color,
      backgroundColor: COLORS[look],
      border: "1px solid ".concat(COLORS[look])
    },
    warning: {
      color: color,
      backgroundColor: COLORS[look],
      border: "1px solid ".concat(COLORS[look])
    },
    danger: {
      color: color,
      backgroundColor: COLORS[look],
      border: "1px solid ".concat(COLORS[look])
    }
  }[look]), TYPE.bodyFont[400]), {}, {
    ":empty": {
      display: "none"
    },
    "@media print": {
      color: "#000",
      backgroundColor: "#fff",
      border: "1px solid #000"
    }
  });
}, labelAttributes = function() {
  return null;
}, defaultLabel = {
  component: Label,
  styles: labelStyles,
  attributes: labelAttributes
}, pkg = {
  name: "@westpac/label",
  version: "1.0.0-beta.2",
  description: "Label component for the Westpac GEL",
  repository: "https://github.com/WestpacGEL/GEL/tree/master/components/label",
  author: "Westpac GEL Team <gel@westpac.com.au>",
  contributors: [ {
    name: "Dominik Wilkowski",
    email: "Hi@Dominik-Wilkowski.com",
    url: "https://dominik-wilkowski.com"
  }, {
    name: "Jonathan Stening",
    email: "info@jonathanstening.com",
    url: "http://jonathanstening.com"
  } ],
  license: "GPL-3.0+",
  scripts: {
    start: "PACKAGE_NAME=label webpack-dev-server --config ../../helpers/example/start.webpack.config.js",
    test: "exit 0 # start-server-and-test start http://localhost:8080 test:all",
    "test:dev": "start-server-and-test start http://localhost:8080 test:test-dev",
    "test:all": "yarn test:integration",
    "test:integration": "cypress run",
    "test:test-dev": "cypress open"
  },
  main: "dist/label.cjs.js",
  module: "dist/label.esm.js",
  dependencies: {
    "@babel/runtime": "^7.9.6",
    "@westpac/core": "^1.0.1",
    "prop-types": "^15.7.2"
  },
  peerDependencies: {
    react: "^16.13.1"
  },
  devDependencies: {
    cypress: "^4.5.0",
    react: "^16.13.1",
    "start-server-and-test": "^1.11.0"
  }
};

function ownKeys$1(object, enumerableOnly) {
  var keys = Object.keys(object);
  if (Object.getOwnPropertySymbols) {
    var symbols = Object.getOwnPropertySymbols(object);
    enumerableOnly && (symbols = symbols.filter((function(sym) {
      return Object.getOwnPropertyDescriptor(object, sym).enumerable;
    }))), keys.push.apply(keys, symbols);
  }
  return keys;
}

function _objectSpread$1(target) {
  for (var i = 1; i < arguments.length; i++) {
    var source = null != arguments[i] ? arguments[i] : {};
    i % 2 ? ownKeys$1(Object(source), !0).forEach((function(key) {
      _defineProperty(target, key, source[key]);
    })) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys$1(Object(source)).forEach((function(key) {
      Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key));
    }));
  }
  return target;
}

var Label$1 = function(_ref) {
  var look = _ref.look, value = _ref.value, componentOverrides = _ref.overrides, rest = _objectWithoutProperties(_ref, [ "look", "value", "overrides" ]), _useBrand = core.useBrand(), tokenOverrides = _useBrand.OVERRIDES[pkg.name], brandOverrides = _useBrand[pkg.name], defaultOverrides = {
    Label: defaultLabel
  }, state = _objectSpread$1({
    look: look,
    value: value,
    overrides: componentOverrides
  }, rest), _overrideReconciler$L = core.overrideReconciler(defaultOverrides, tokenOverrides, brandOverrides, componentOverrides).Label, Label = _overrideReconciler$L.component, labelStyles = _overrideReconciler$L.styles, labelAttributes = _overrideReconciler$L.attributes;
  return core.jsx(Label, _extends({}, rest, {
    state: state
  }, labelAttributes(state), {
    css: {
      "&&": labelStyles(state)
    }
  }), value);
};

Label$1.propTypes = {
  look: PropTypes.oneOf([ "primary", "hero", "neutral", "faint", "success", "info", "warning", "danger" ]).isRequired,
  value: PropTypes.string.isRequired,
  overrides: PropTypes.shape({
    Label: PropTypes.shape({
      styles: PropTypes.func,
      component: PropTypes.elementType,
      attributes: PropTypes.func
    })
  })
}, Label$1.defaultProps = {
  look: "primary"
}, exports.Label = Label$1;
